#include <iostream>
#include <string>
#include <list>
#include <algorithm>
#include <functional>
#include <boost/bind.hpp>

using namespace std;

struct Employee {
    Employee(const string& n, const string& a) : name(n), addr(a) {}
	string name;
	string addr;
};

string FindAddr( const list<Employee>& l, const string& name )
{
	string addr;
	list<Employee>::const_iterator i =
		find_if( l.begin(), l.end(), boost::bind(equal_to<string>(), boost::bind(&Employee::name, _1), name) );
	if( i != l.end() )
		addr = (*i).addr;
    return addr;
}

int main() {
	list<Employee> l;
	l.push_back( Employee("Ala", "W-wa") );
	l.push_back( Employee("Ela", "Krakow") );
	l.push_back( Employee("Ola", "Gdansk") );

	cout << FindAddr(l, "Ala") << endl;
	return 0;
}

